% SelectRand.m
% SELECTRAND chooses numLabs * numIDsPerFile unique random integers 
% from 1 through maxID.  Then, from the file activities-portland-1-v1.dat
% it creates numLabs number of files, with each file containing the
% second and seventh columns of data and all the activities for
% numIDsPerFile number of people.

numIDsPerFile = 20000;
numLabs = 2;
numEls = numLabs * numIDsPerFile;
maxID = 1615860;

% select numEls unique uniformly distributed random integers in 1:maxID
ids = randi(maxID, 1, numEls);
ids = unique(ids);
while length(ids) < numEls
    el = randi(maxID);
    ids = unique([ids, el]);
end

% create the output files
ndx = 1;
beyoundLastID = ids(numEls) + 1;
inFID = fopen('activities-portland-1-v1.dat', 'r');
outFID = fopen(['rand_' num2str(numEls) 'Els.txt'], 'w');

id = 0;
while id < beyoundLastID
    % skip over unneeded lines
    while id < ids(ndx)
        currRow = fscanf(inFID, '%*d %d %*d %*d %*d %*d %d', [1 2]);
        id = currRow(1);
    end;
    
    % process needed lines
    while id == ids(ndx)
       fprintf(outFID, '%d %d\n', currRow);
       currRow = fscanf(inFID, '%*d %d %*d %*d %*d %*d %d', [1 2]);
       id = currRow(1);
    end
    ndx = ndx + 1;
end
fclose(inFID);
fclose(outFID);


